summaryrefslogtreecommitdiffstats
path: root/development/rust16
diff options
context:
space:
mode:
Diffstat (limited to 'development/rust16')
-rw-r--r--development/rust16/README21
-rw-r--r--development/rust16/rust16.SlackBuild141
-rw-r--r--development/rust16/rust16.info12
-rw-r--r--development/rust16/slack-desc19
4 files changed, 193 insertions, 0 deletions
diff --git a/development/rust16/README b/development/rust16/README
new file mode 100644
index 0000000000..97cfbe0b15
--- /dev/null
+++ b/development/rust16/README
@@ -0,0 +1,21 @@
+rust16 installs a limited set of Rust stable binaries to /opt/rust16.
+This is to allow Rust-based SlackBuilds to build more recent versions
+than would be possible with system Rust.
+
+To use the rust16 binaries in a SlackBuild, make the following export
+statements:
+
+export PATH="/opt/rust16/bin:$PATH"
+if [ -z "$LD_LIBRARY_PATH" ]; then
+ export LD_LIBRARY_PATH="/opt/rust16/lib$LIBDIRSUFFIX"
+else
+ export LD_LIBRARY_PATH="/opt/rust16/lib$LIBDIRSUFFIX:$LD_LIBRARY_PATH"
+fi
+
+If your SlackBuild experiences build failures on 64-bit systems, please
+ensure that the LIBDIRSUFFIX variable is set.
+
+rust16 is not intended as a substitute for rustup or for the Slackware
+Rust package in terms of Rust development purposes.
+
+Separate downloads are available for i686 and x86_64.
diff --git a/development/rust16/rust16.SlackBuild b/development/rust16/rust16.SlackBuild
new file mode 100644
index 0000000000..76d28a8f68
--- /dev/null
+++ b/development/rust16/rust16.SlackBuild
@@ -0,0 +1,141 @@
+#!/bin/bash
+
+# Slackware build script for rust16
+
+# Copyright 2023-2024 K. Eugene Carlson Tsukuba, Japan
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=rust16
+SRCNAM=rust
+VERSION=${VERSION:-1.78.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+
+ if [ "$ARCH" = "i586" ]; then
+ if rustc -Vv | grep host | grep -q i686; then
+ ARCH=i686
+ fi
+ fi
+fi
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ LIBDIRSUFFIX="64"
+else
+ LIBDIRSUFFIX=""
+fi
+
+if [ "$ARCH" = "arm" ]; then
+ TRIPLET="$ARCH-unknown-linux-gnueabihf"
+else
+ TRIPLET="$ARCH-unknown-linux-gnu"
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-$VERSION-$TRIPLET
+tar xvf $CWD/$SRCNAM-$VERSION-$TRIPLET.tar.gz
+cd $SRCNAM-$VERSION-$TRIPLET
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+./install.sh \
+ --destdir=$PKG \
+ --prefix="opt/rust16" \
+ --disable-ldconfig \
+ --without=rust-docs-json-preview,\
+rust-docs,\
+clippy-preview,\
+rls-preview,\
+llvm-tools-preview,\
+rust-analysis-$TRIPLET,\
+rust-analyzer-preview,\
+rust-demangler-preview,\
+rustfmt-preview
+
+find $PKG/opt/$PRGNAM/lib -type f -name "*.so" -exec chmod +x {} \; 2> /dev/null || true
+find $PKG/opt/$PRGNAM/lib -type f -name "*.so*stable" -exec chmod +x {} \; 2> /dev/null || true
+# As of 1.78.0, stripping the libraries causes memory faults on Slackware64-15.0.
+if [ $ARCH = "x86_64" ]; then
+ find $PKG -print0 | xargs -0 file | grep "executable" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+else
+ find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+fi
+
+rm -f $PKG/opt/$PRGNAM/lib/rustlib/uninstall.sh
+rm -f $PKG/opt/$PRGNAM/lib/rustlib/install.log
+rm -f $PKG/opt/$PRGNAM/lib/rustlib/manifest-*
+rm -f $PKG/opt/$PRGNAM/lib/rustlib/rust-installer-version
+rm -f $PKG/opt/$PRGNAM/lib/rustlib/components
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ $PKG/opt/$PRGNAM/share/doc/* \
+ COPYRIGHT LICENSE-APACHE LICENSE-MIT \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+cat $CWD/README > $PKG/usr/doc/$PRGNAM-$VERSION/README.sw
+
+# Nothing in share is needed at this point.
+rm -rf $PKG/opt/$PRGNAM/share
+# Don't need bash completions.
+rm -rf $PKG/opt/$PRGNAM/etc
+# Appropriate directory name for the lib dir.
+[ -n "$LIBDIRSUFFIX" ] && mv $PKG/opt/$PRGNAM/lib $PKG/opt/$PRGNAM/lib$LIBDIRSUFFIX
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/development/rust16/rust16.info b/development/rust16/rust16.info
new file mode 100644
index 0000000000..e3ea0781ec
--- /dev/null
+++ b/development/rust16/rust16.info
@@ -0,0 +1,12 @@
+PRGNAM="rust16"
+VERSION="1.78.0"
+HOMEPAGE="https://rust-lang.org"
+DOWNLOAD="https://static.rust-lang.org/dist/2024-05-02/rust-1.78.0-i686-unknown-linux-gnu.tar.gz \
+ https://static.rust-lang.org/dist/2024-05-02/rust-1.78.0-arm-unknown-linux-gnueabihf.tar.gz"
+MD5SUM="b5563989498e9db2b910de1e70f940cc \
+ c4e256bec2b46f609afea9f7ccd48fd0"
+DOWNLOAD_x86_64="https://static.rust-lang.org/dist/2024-05-02/rust-1.78.0-x86_64-unknown-linux-gnu.tar.gz"
+MD5SUM_x86_64="73118081f69aff0622ce96c9202ef4e0"
+REQUIRES=""
+MAINTAINER="K. Eugene Carlson"
+EMAIL="kvngncrlsn@gmail.com"
diff --git a/development/rust16/slack-desc b/development/rust16/slack-desc
new file mode 100644
index 0000000000..59a492264e
--- /dev/null
+++ b/development/rust16/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+rust16: rust16 (Rust: a safe, concurrent, practical language)
+rust16:
+rust16: rust16 installs a limited set of up-to-date Rust stable binaries to
+rust16: /opt/rust16 for use in SlackBuilds.
+rust16:
+rust16:
+rust16:
+rust16:
+rust16:
+rust16:
+rust16: Homepage: https://rust-lang.org